# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Security::Mgmt::V2020_01_01
  module Models
    #
    # Model object.
    #
    #
    class AppWhitelistingGroup

      include MsRestAzure

      # @return [String] Resource Id
      attr_accessor :id

      # @return [String] Resource name
      attr_accessor :name

      # @return [String] Resource type
      attr_accessor :type

      # @return [String] Location where the resource is stored
      attr_accessor :location

      # @return [Enum] Possible values include: 'Audit', 'Enforce', 'None'
      attr_accessor :enforcement_mode

      # @return [ProtectionMode]
      attr_accessor :protection_mode

      # @return [Enum] Possible values include: 'Configured', 'NotConfigured',
      # 'InProgress', 'Failed', 'NoStatus'
      attr_accessor :configuration_status

      # @return [Enum] Possible values include: 'Recommended',
      # 'NotRecommended', 'NotAvailable', 'NoStatus'
      attr_accessor :recommendation_status

      # @return [Array<AppWhitelistingIssueSummary>]
      attr_accessor :issues

      # @return [Enum] Possible values include: 'Azure_AppLocker',
      # 'Azure_AuditD', 'NonAzure_AppLocker', 'NonAzure_AuditD', 'None'
      attr_accessor :source_system

      # @return [Array<VmRecommendation>]
      attr_accessor :vm_recommendations

      # @return [Array<PathRecommendation>]
      attr_accessor :path_recommendations


      #
      # Mapper for AppWhitelistingGroup class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'AppWhitelistingGroup',
          type: {
            name: 'Composite',
            class_name: 'AppWhitelistingGroup',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              location: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'location',
                type: {
                  name: 'String'
                }
              },
              enforcement_mode: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.enforcementMode',
                type: {
                  name: 'String'
                }
              },
              protection_mode: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.protectionMode',
                type: {
                  name: 'Composite',
                  class_name: 'ProtectionMode'
                }
              },
              configuration_status: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.configurationStatus',
                type: {
                  name: 'String'
                }
              },
              recommendation_status: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.recommendationStatus',
                type: {
                  name: 'String'
                }
              },
              issues: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.issues',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'AppWhitelistingIssueSummaryElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'AppWhitelistingIssueSummary'
                      }
                  }
                }
              },
              source_system: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.sourceSystem',
                type: {
                  name: 'String'
                }
              },
              vm_recommendations: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.vmRecommendations',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'VmRecommendationElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'VmRecommendation'
                      }
                  }
                }
              },
              path_recommendations: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.pathRecommendations',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'PathRecommendationElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'PathRecommendation'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
